# openforcefield.utils.toolkits.ToolkitWrapper

class `openforcefield.utils.toolkits.``ToolkitWrapper`

  Toolkit wrapper base class.

  Warning

  This API is experimental and subject to change.

  Attributes
    `toolkit_file_read_formats`

      List of file formats that this toolkit can read.

    `toolkit_file_write_formats`

      List of file formats that this toolkit can write.

    `toolkit_installation_instructions`

      classmethod(function) -> method

    `toolkit_name`

      The name of the toolkit wrapped by this class.

  Methods

  `from_file`(self, file_path, file_format[, …]) | Return an openforcefield.topology.Molecule from a file using this toolkit.
  `from_file_obj`(self, file_obj, file_format[, …]) | Return an openforcefield.topology.Molecule from a file-like object (an object with a “.read()” method using this
  `is_available`() | Check whether the corresponding toolkit can be imported
  `requires_toolkit`() |

  `__init__`(self, /, *args, **kwargs)

    Initialize self. See help(type(self)) for accurate signature.

  Methods

  `__init__`(self, /, \*args, \*\*kwargs) | Initialize self.
  `from_file`(self, file_path, file_format[, …]) | Return an openforcefield.topology.Molecule from a file using this toolkit.
  `from_file_obj`(self, file_obj, file_format[, …]) | Return an openforcefield.topology.Molecule from a file-like object (an object with a “.read()” method using this
  `is_available`() | Check whether the corresponding toolkit can be imported
  `requires_toolkit`() |

  Attributes

  `toolkit_file_read_formats` | List of file formats that this toolkit can read.
  `toolkit_file_write_formats` | List of file formats that this toolkit can write.
  `toolkit_installation_instructions` | classmethod(function) -> method
  `toolkit_name` | The name of the toolkit wrapped by this class.

  property `toolkit_name`

    The name of the toolkit wrapped by this class.

  property `toolkit_installation_instructions`

    classmethod(function) -> method

    Convert a function to be a class method.

    A class method receives the class as implicit first argument, just like an instance method receives the instance. To declare a class method, use this idiom:

    > class C:

    >   @classmethod def f(cls, arg1, arg2, …):

    >   > …

    It can be called either on the class (e.g. C.f()) or on an instance (e.g. C().f()). The instance is ignored except for its class. If a class method is called for a derived class, the derived class object is passed as the implied first argument.

    Class methods are different than C++ or Java static methods. If you want those, see the staticmethod builtin.

  property `toolkit_file_read_formats`

    List of file formats that this toolkit can read.

  property `toolkit_file_write_formats`

    List of file formats that this toolkit can write.

  static `is_available`()

    Check whether the corresponding toolkit can be imported

    Returns
      is_installed bool

        True if corresponding toolkit is installed, False otherwise.

  `from_file`(self, file_path, file_format, allow_undefined_stereo=False)

    Return an openforcefield.topology.Molecule from a file using this toolkit.

    Parameters
      file_path str

        The file to read the molecule from

      file_format str

        Format specifier, usually file suffix (eg. ‘MOL2’, ‘SMI’) Note that not all toolkits support all formats. Check ToolkitWrapper.toolkit_file_read_formats for details.

      allow_undefined_stereo bool, default=False

        If false, raises an exception if any molecules contain undefined stereochemistry.

      Returns
      ——-
      molecules Molecule or list of Molecules

        a list of Molecule objects is returned.

  `from_file_obj`(self, file_obj, file_format, allow_undefined_stereo=False)
    Return an openforcefield.topology.Molecule from a file-like object (an object with a “.read()” method using this

      toolkit.

    Parameters
      file_obj file-like object

        The file-like object to read the molecule from

      file_format str

        Format specifier, usually file suffix (eg. ‘MOL2’, ‘SMI’) Note that not all toolkits support all formats. Check ToolkitWrapper.toolkit_file_read_formats for details.

      allow_undefined_stereo bool, default=False

        If false, raises an exception if any molecules contain undefined stereochemistry. If false, the function skips loading the molecule.

    Returns
      molecules Molecule or list of Molecules

        a list of Molecule objects is returned.